property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "image_cells"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:%20image_cells%20(v" & script_version & ")"
property script_donation_url : "https://order.kagi.com/?ELJ"

property stop_progress : false

property first_run : true

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run = true then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run = true then center
		end tell
		
	else if object_name = "prefs" then
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
			end tell
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "prefs" then
		display window "prefs" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "stop_progress" then
		set my stop_progress to false
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "donate" then
		open location script_donation_url
		
	else if object_name = "load" then
		set the_folder to (choose folder with prompt "Choose a folder with JPEG files:") as Unicode text
		my progress_show("Searching for JPEGs", "Searching folder " & the_folder & "...")
		set the_images to paragraphs of (do shell script "find " & (quoted form of POSIX path of the_folder) & " -iname '*.jpg' | tr -s '/'")
		if the_images = {} then
			my progress_hide()
			my display_error("No Images Found", "No JPEGs were found in the folder " & the_folder & ". Please try a different folder.")
		else
			my progress_show("Prepping Image Table", "")
			call method "disableFlushWindow" of window "main"
			set the_table to table view 1 of scroll view 1 of window "main"
			set the_data_source to data source of the_table
			tell the_data_source
				try
					delete data rows
				end try
				try
					delete data columns
				end try
				make new data column at end of data columns with properties {name:"image"}
				make new data column at end of data columns with properties {name:"path"}
				set {stop_progress, iteration, total_count, super_message} to {true, 1, (count of the_images), "Loading Image Table"}
				repeat with this_image in the_images
					if stop_progress = false then exit repeat
					my progress_update(iteration, total_count, super_message, "Loading image " & (contents of this_image) & " (" & iteration & " of " & total_count & ")...")
					try
						set the_row to make new data row at end of data rows
						tell the_row
							set contents of data cell 1 to (load image (contents of this_image))
							set contents of data cell 2 to (contents of this_image)
						end tell
					on error the_error
						my update_status("load image error: " & the_error)
					end try
					set iteration to iteration + 1
				end repeat
			end tell
			tell window "main" to update
			call method "enableFlushWindow" of window "main"
			my progress_hide()
		end if
		
	end if
end clicked

on action the_object
	set object_name to name of the_object as Unicode text
	my update_status("action " & object_name)
end action

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on will quit the_object
	my quit_prep()
	return true
end will quit

on idle the_object
	return 1
end idle

on should quit the_object
	return true
end should quit

on quit_prep()
	set panel_wins to name of (windows whose class = panel and visible = true)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
	my write_settings()
	set quitting to true
end quit_prep

on progress_show(super_message, the_message)
	set stop_progress to true
	tell window "progress"
		set indeterminate of progress indicator "progress" to true
		set uses threaded animation of progress indicator "progress" to true
		tell progress indicator "progress" to start
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		update
	end tell
	if visible of window "progress" = false then display window "progress" attached to window "main"
end progress_show

on progress_update(iteration, total_count, super_message, the_message)
	tell window "progress"
		if iteration = 1 then
			tell progress indicator "progress" to stop
			set indeterminate of progress indicator "progress" to false
		end if
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		set maximum value of progress indicator "progress" to total_count
		set content of progress indicator "progress" to iteration
		update
	end tell
end progress_update

on progress_hide()
	close panel window "progress"
	tell window "progress"
		set contents of text field "progress_label_super" to ""
		set contents of text field "progress_label" to ""
		set content of progress indicator "progress" to 0
		tell progress indicator "progress" to stop
		set indeterminate of progress indicator "progress" to false
		update
	end tell
end progress_hide

on display_error(the_title, the_error)
	activate
	beep
	my update_status("Error: " & the_error)
	display alert the_title as critical message the_error default button "OK" attached to window "main"
end display_error

on display_warning(the_warning, the_buttons, default_button)
	activate
	beep
	return button returned of (display dialog the_warning buttons the_buttons default button default_button with icon 2)
end display_warning

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me = true then log the_message
end update_status

